package org.ow2.bonita.example.aw;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.security.auth.login.LoginContext;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.bonita.facade.ManagementAPI;
import org.ow2.bonita.facade.QueryDefinitionAPI;
import org.ow2.bonita.facade.QueryRuntimeAPI;
import org.ow2.bonita.facade.RuntimeAPI;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition;
import org.ow2.bonita.facade.uuid.PackageDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.util.AccessorUtil;
import org.ow2.novabpm.util.Misc;
import org.ow2.novabpm.util.SimpleCallbackHandler;

@SuppressWarnings("serial")
public class AWAction extends HttpServlet {

  /**
   * Constructor of the object.
   */
  public AWAction() {
    super();
  }

  public void destroy() {
    super.destroy();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    final String userName = request.getParameter("username");
    final String password = request.getParameter("password");
    final String action = request.getParameter("Action");
    
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    AWCommon.writeStart(out);
    
    final org.ow2.bonita.example.aw.ApprovalWorkflow approval = new org.ow2.bonita.example.aw.ApprovalWorkflow();
    
    try {
      final LoginContext loginContext = new LoginContext("Bonita", new SimpleCallbackHandler(userName, password));
      loginContext.login(); 
      
      final RuntimeAPI runtimeAPI = AccessorUtil.getAPIAccessor().getRuntimeAPI();
      final QueryRuntimeAPI queryRuntimeAPI = AccessorUtil.getAPIAccessor().getQueryRuntimeAPI();
      final ManagementAPI managementAPI = AccessorUtil.getAPIAccessor().getManagementAPI();
      final QueryDefinitionAPI queryDefinitionAPI = AccessorUtil.getAPIAccessor().getQueryDefinitionAPI();
      
      if (action.equals("Deploy")) {
        String barFile = request.getParameter("BarFile");
        final File file = new File(barFile);
        if (!file.exists()) {
          throw new Exception("The given file : " + file 
              + " does not exist. Are you sure you have generated the bar file ?");
        }
        
        final ProcessDefinition process = approval.deploy(managementAPI, barFile).get(approval.getProcessId());
        out.println("<br>Informations about deployment :");
        out.println("<br>Process Name : " + process.getName());
        out.println("<br>Process ID : " + process.getProcessId());
        out.println("<br>Process UUID : " + process.getUUID());

      } else if (action.equals("StartYes") || action.equals("StartNo")) {
        boolean granted = action.equals("StartYes");
        approval.setGranted(granted);
        
        ProcessDefinition process = 
          queryDefinitionAPI.getLastProcess(approval.getPackageId(), approval.getProcessId());
        ProcessDefinitionUUID processUUID = process.getUUID();
        
        ProcessInstanceUUID instanceUUID = approval.instantiate(null, runtimeAPI, processUUID);
        
        approval.afterInstantiate(instanceUUID, processUUID, runtimeAPI, queryRuntimeAPI, queryDefinitionAPI);
        
      } else if (action.equals("UndeployDelete")) {
        ProcessDefinition process = 
          queryDefinitionAPI.getLastProcess(approval.getPackageId(), approval.getProcessId());

        PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
        managementAPI.undeploy(packageUUID);
        managementAPI.deletePackage(packageUUID);
        out.println("<br>Package with UUID " + packageUUID + "  was succesully undeployed and deleted");
        
      }

      loginContext.logout();
    } catch (Exception e1) {
      String stacktrace = Misc.getStackTraceFrom(e1);
      
      out.println("<div align='left'>");
      out.println(stacktrace.replaceAll("\n", "<br>"));
      out.println("</div>");
      e1.printStackTrace();
    }
    out.println("<br><br><br>");
    out.println("<form  name='form' method='get' action='" + AWCommon.ACTIONS_URL + "'>");
    out.println("<input type='submit' value='BACK TO ACTIONS' name='back'>");
    out.println("<input type='hidden' name='username' value='" + userName + "'>");
    out.println("<input type='hidden' name='password' value='" + password + "'>");
    out.println("</form>");
    
    AWCommon.writeEnd(out);
    out.flush();
    out.close();
  }

  public void init() throws ServletException {

  }

}

