package org.ow2.bonita.example.carpool.hook;




import java.util.logging.Level;
import java.util.logging.Logger;

import org.ow2.bonita.definition.TxHook;
import org.ow2.bonita.facade.APIAccessor;
import org.ow2.bonita.facade.RuntimeAPI;
import org.ow2.bonita.facade.runtime.ActivityBody;
import org.ow2.bonita.facade.runtime.ActivityInstance;
import org.ow2.bonita.facade.runtime.TaskInstance;

public class CancelRequestDL implements TxHook {

  private static final Logger LOG = Logger.getLogger(CancelRequestDL.class.getName());

  public void execute(APIAccessor apiAccessor, ActivityInstance<ActivityBody> activity) throws Exception {
    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Executing Hook: " + this.getClass().getName() + " *****\n");
    }
    TaskInstance t = (TaskInstance) activity.getBody();
    RuntimeAPI runtimeAPI = apiAccessor.getRuntimeAPI();
    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Starting task associated to activity: " + activity.getActivityId() + " *****\n");
    }
    runtimeAPI.startTask(t.getUUID(), true);
    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Finishing task associated to activity: " + activity.getActivityId() + " *****\n");
    }
    runtimeAPI.finishTask(t.getUUID(), true);
  }

}
