package org.ow2.bonita.example.carpool.hook;

import java.util.logging.Level;
import java.util.logging.Logger;

import junit.framework.Assert;

import org.ow2.bonita.definition.TxHook;
import org.ow2.bonita.facade.APIAccessor;
import org.ow2.bonita.facade.RuntimeAPI;
import org.ow2.bonita.facade.runtime.ActivityBody;
import org.ow2.bonita.facade.runtime.ActivityInstance;
import org.ow2.bonita.facade.runtime.TaskInstance;
import org.ow2.bonita.facade.runtime.TaskState;
import org.ow2.bonita.facade.uuid.TaskUUID;

public class WaitRequestDL implements TxHook {

  private static final Logger LOG = Logger.getLogger(WaitRequestDL.class.getName());

  public void execute(APIAccessor apiAccessor, ActivityInstance<ActivityBody> activity) throws Exception {
    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Executing Hook: " + this.getClass().getName() + " *****\n");
    }

    String activityId = activity.getActivityId();
    TaskInstance t = (TaskInstance)activity.getBody();
    TaskUUID taskUUID = t.getUUID();
    RuntimeAPI runtimeAPI = apiAccessor.getRuntimeAPI();

    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Starting task associated to activity: " + activityId + " *****\n");
    }
    runtimeAPI.startTask(taskUUID, true);

    ActivityInstance<TaskInstance> activity2 = apiAccessor.getQueryRuntimeAPI().getTask(taskUUID);
    Assert.assertNotNull(activity2);
    t = activity2.getBody();
    Assert.assertEquals("Task is in a wrong state!", TaskState.EXECUTING, t.getState());

    if (LOG.isLoggable(Level.INFO)) {
      LOG.info("\n***** Finishing task associated to activity: " + activityId + " *****\n");
    }
    runtimeAPI.finishTask(taskUUID, true);
  }

}
